datablock ItemData(WoodenDoorItem)
{
	 // Basic Item Properties
	shapeFile = "./WallItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Wooden Door";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.66 0.46 0.27 1.0";

	 // Dynamic properties defined by the scripts
	image = WoodenDoorImage;
	canDrop = true;
};

datablock ShapeBaseImageData(WoodenDoorImage)
{
   // Basic Item properties
   shapeFile = "./WallItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = WoodenDoorItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = WoodenDoorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function WoodenDoorImage::checkPlacement(%this,%obj,%slot){
	CheckDoorPlacement(%this,%obj,%slot);
}

function WoodenDoorImage::onFire(%this,%obj,%slot){
	DoorPlace(%this,%obj,%slot,"Wooden");
}

function WoodenDoorImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function WoodenDoorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}

//Stone
datablock ItemData(StoneDoorItem)
{
	 // Basic Item Properties
	shapeFile = "./WallItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Stone Door";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.59 0.59 0.59 1.0";

	 // Dynamic properties defined by the scripts
	image = StoneDoorImage;
	canDrop = true;
};

datablock ShapeBaseImageData(StoneDoorImage)
{
   // Basic Item properties
   shapeFile = "./WallItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = StoneDoorItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = StoneDoorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function StoneDoorImage::checkPlacement(%this,%obj,%slot){
	CheckDoorPlacement(%this,%obj,%slot);
}

function StoneDoorImage::onFire(%this,%obj,%slot){
	DoorPlace(%this,%obj,%slot,"Stone");
}

function StoneDoorImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function StoneDoorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}

//Metal
datablock ItemData(MetalDoorItem)
{
	 // Basic Item Properties
	shapeFile = "./WallItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Metal Door";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.86 0.86 0.86 1.0";

	 // Dynamic properties defined by the scripts
	image = MetalDoorImage;
	canDrop = true;
};

datablock ShapeBaseImageData(MetalDoorImage)
{
   // Basic Item properties
   shapeFile = "./WallItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = MetalDoorItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = MetalDoorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function MetalDoorImage::checkPlacement(%this,%obj,%slot){
	CheckDoorPlacement(%this,%obj,%slot);
}

function MetalDoorImage::onFire(%this,%obj,%slot){
	DoorPlace(%this,%obj,%slot,"Metal");
}

function MetalDoorImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function MetalDoorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}