datablock ItemData(WoodenFloorItem)
{
	 // Basic Item Properties
	shapeFile = "./FloorItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Wooden Floor";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.66 0.46 0.27 1.0";

	 // Dynamic properties defined by the scripts
	image = WoodenFloorImage;
	canDrop = true;
};

datablock ShapeBaseImageData(WoodenFloorImage)
{
   // Basic Item properties
   shapeFile = "./FloorItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = WoodenFloorItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = WoodenFloorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function WoodenFloorImage::checkPlacement(%this,%obj,%slot){
	CheckFloorPlacement(%this,%obj,%slot);
}

function WoodenFloorImage::onFire(%this,%obj,%slot){
	FloorPlace(%this,%obj,%slot,"Wooden");
}

function WoodenFloorImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function WoodenFloorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}

//Stone
datablock ItemData(StoneFloorItem)
{
	 // Basic Item Properties
	shapeFile = "./FloorItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Stone Floor";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.59 0.59 0.59 1.0";

	 // Dynamic properties defined by the scripts
	image = StoneFloorImage;
	canDrop = true;
};

datablock ShapeBaseImageData(StoneFloorImage)
{
   // Basic Item properties
   shapeFile = "./FloorItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = StoneFloorItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = StoneFloorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function StoneFloorImage::checkPlacement(%this,%obj,%slot){
	CheckFloorPlacement(%this,%obj,%slot);
}

function StoneFloorImage::onFire(%this,%obj,%slot){
	FloorPlace(%this,%obj,%slot,"Stone");
}

function StoneFloorImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function StoneFloorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}

//Metal
datablock ItemData(MetalFloorItem)
{
	 // Basic Item Properties
	shapeFile = "./FloorItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Metal Floor";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.86 0.86 0.86 1.0";

	 // Dynamic properties defined by the scripts
	image = MetalFloorImage;
	canDrop = true;
};

datablock ShapeBaseImageData(MetalFloorImage)
{
   // Basic Item properties
   shapeFile = "./FloorItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = MetalFloorItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = MetalFloorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function MetalFloorImage::checkPlacement(%this,%obj,%slot){
	CheckFloorPlacement(%this,%obj,%slot);
}

function MetalFloorImage::onFire(%this,%obj,%slot){
	FloorPlace(%this,%obj,%slot,"Metal");
}

function MetalFloorImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function MetalFloorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}