datablock ItemData(WoodenPillarItem)
{
	 // Basic Item Properties
	shapeFile = "./PillarItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Wooden Pillar";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.66 0.46 0.27 1.0";

	 // Dynamic properties defined by the scripts
	image = WoodenPillarImage;
	canDrop = true;
};

datablock ShapeBaseImageData(WoodenPillarImage)
{
   // Basic Item properties
   shapeFile = "./PillarItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = WoodenPillarItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = WoodenPillarItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function WoodenPillarImage::checkPlacement(%this,%obj,%slot){
	CheckPillarPlacement(%this,%obj,%slot);
}

function WoodenPillarImage::onFire(%this,%obj,%slot){
	PillarPlace(%this,%obj,%slot,"Wooden");
}

function WoodenPillarImage::onUnMount(%this,%obj,%slot){
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function WoodenFloorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}

//Stone
datablock ItemData(StonePillarItem)
{
	 // Basic Item Properties
	shapeFile = "./PillarItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Stone Pillar";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.59 0.59 0.59 1.0";

	 // Dynamic properties defined by the scripts
	image = StonePillarImage;
	canDrop = true;
};

datablock ShapeBaseImageData(StonePillarImage)
{
   // Basic Item properties
   shapeFile = "./PillarItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = StonePillarItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = StonePillarItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function StonePillarImage::checkPlacement(%this,%obj,%slot){
	CheckPillarPlacement(%this,%obj,%slot);
}

function StonePillarImage::onFire(%this,%obj,%slot){
	PillarPlace(%this,%obj,%slot,"Stone");
}

function StonePillarImage::onUnMount(%this,%obj,%slot){
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function StoneFloorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}

//Metal
datablock ItemData(MetalPillarItem)
{
	 // Basic Item Properties
	shapeFile = "./PillarItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Metal Pillar";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.86 0.86 0.86 1.0";

	 // Dynamic properties defined by the scripts
	image = MetalPillarImage;
	canDrop = true;
};

datablock ShapeBaseImageData(MetalPillarImage)
{
   // Basic Item properties
   shapeFile = "./PillarItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   SnapBuildRotate=true;

   // Projectile && Ammo.
   item = MetalPillarItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = MetalPillarItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function MetalPillarImage::checkPlacement(%this,%obj,%slot){
	CheckPillarPlacement(%this,%obj,%slot);
}

function MetalPillarImage::onFire(%this,%obj,%slot){
	PillarPlace(%this,%obj,%slot,"Metal");
}

function MetalPillarImage::onUnMount(%this,%obj,%slot){
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

function MetalFloorImage::onMount(%this,%obj,%slot){
	
	%obj.client.SnapRotate=1;
	
}