datablock ItemData(WoodenRoofItem)
{
	 // Basic Item Properties
	shapeFile = "./FloorItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Wooden Roof";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.66 0.46 0.27 1.0";

	 // Dynamic properties defined by the scripts
	image = WoodenRoofImage;
	canDrop = true;
};

datablock ShapeBaseImageData(WoodenRoofImage)
{
   // Basic Item properties
   shapeFile = "./FloorItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = WoodenRoofItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = WoodenRoofItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function WoodenRoofImage::checkPlacement(%this,%obj,%slot){
	CheckRoofPlacement(%this,%obj,%slot);
}

function WoodenRoofImage::onFire(%this,%obj,%slot){
	RoofPlace(%this,%obj,%slot,"Wooden");
}

function WoodenRoofImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

//Stone
datablock ItemData(StoneRoofItem)
{
	 // Basic Item Properties
	shapeFile = "./FloorItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Stone Roof";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.59 0.59 0.59 1.0";

	 // Dynamic properties defined by the scripts
	image = StoneRoofImage;
	canDrop = true;
};

datablock ShapeBaseImageData(StoneRoofImage)
{
   // Basic Item properties
   shapeFile = "./FloorItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = StoneRoofItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = StoneRoofItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function StoneRoofImage::checkPlacement(%this,%obj,%slot){
	CheckRoofPlacement(%this,%obj,%slot);
}

function StoneRoofImage::onFire(%this,%obj,%slot){
	RoofPlace(%this,%obj,%slot,"Stone");
}

function StoneRoofImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}

//Metal
datablock ItemData(MetalRoofItem)
{
	 // Basic Item Properties
	shapeFile = "./FloorItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Metal Roof";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.86 0.86 0.86 1.0";

	 // Dynamic properties defined by the scripts
	image = MetalRoofImage;
	canDrop = true;
};

datablock ShapeBaseImageData(MetalRoofImage)
{
   // Basic Item properties
   shapeFile = "./FloorItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MetalRoofItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = MetalRoofItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.2;
   stateTransitionOnTimeout[1] = "Ready";
   stateWaitForTimeout[1] = false;
   stateScript[1] = "checkPlacement";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTimeoutValue[2] = 0.2;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function MetalRoofImage::checkPlacement(%this,%obj,%slot){
	CheckRoofPlacement(%this,%obj,%slot);
}

function MetalRoofImage::onFire(%this,%obj,%slot){
	RoofPlace(%this,%obj,%slot,"Metal");
}

function MetalRoofImage::onUnMount(%this,%obj,%slot){

	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
}