datablock ItemData(SnapHammerItem)
{
	 // Basic Item Properties
	shapeFile = "./SnapHammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Snap Hammer";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.66 0.46 0.27 1.0";

	 // Dynamic properties defined by the scripts
	image = SnapHammerImage;
	canDrop = true;
};

datablock ShapeBaseImageData(SnapHammerImage)
{
   // Basic Item properties
   shapeFile = "./SnapHammer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SnapHammerItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   showBricks = false;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = SnapHammerItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0] = "Activate";
   stateTimeoutValue[0] = 0.1;
   stateTransitionOnTimeout[0] = "Ready";
   stateSound[0] = weaponSwitchSound;

   stateName[1] = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1] = true;
   stateTimeoutValue[1] = 0.25;
   stateScript[1] = "onStopFire";

   stateName[2] = "Fire";
   stateTransitionOnTriggerUp[2] = "Ready";
   stateTransitionOnTimeout[2] = "Fire";
   stateTimeoutValue[2] = 0.25;
   stateFire[2] = true;
   stateAllowImageChange[2] = false;
   stateWaitForTimeout[2] = true;
   stateScript[2] = "onFire";
};

function SnapHammerImage::onMount(%this,%obj,%slot){
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>SnapHammer Mode:<color:fff000>" SPC %obj.client.SnapHammerMode);
	
}

function SnapHammerImage::onUnMount(%this,%obj,%slot){
	
	bottomPrint(%obj.client,"");
	
}

function SnapHammerImage::onFire(%this,%obj,%slot){
	
	//Raycast shit
	%obj.playthread(2, armattack);
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = firstWord(containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::StaticObjectType,%obj));
	
	if(%raycast && %raycast.getClassName() $= "StaticShape" && %raycast.getDatablock().isSnapBuild){
	
		if(%obj.client.SnapHammerMode $= "Destroy"){
			if(%raycast.bl_id == %obj.client.bl_id){
				%raycast.delete();
			}else{
				centerPrint(%obj.client,"This is not<br>your snap piece.<br>BLID: " @ %raycast.bl_id,0.5);
			}
		}else if(%obj.client.SnapHammerMode $= "Repair"){
			
			//Let workout which piece it is so we know what the maxhealth is.
			%dataBlock=%raycast.getDatablock();
			
			if(%dataBlock.isPillar){
				%maxHP=250;
			}else if(%dataBlock.isWall){
				%maxHP=375;
			}else if(%dataBlock.isRoof){
				%maxHP=250;
			}else if(%dataBlock.isFloor){
				%maxHP=500;
			}
			
			if(%raycast.HP+20 < %maxHP){
				
				%raycast.HP+=20; //Repair the piece by 10 health per hit, making it 40HP/Second
				
				%percentage=mFloor((%raycast.HP/%maxHP)*100);
				
				if(%percentage >= 50){
					%color="<color:00ff00>";
				}else if(%percentage >= 25){
					%color="<color:fff000>";
				}else{
					%color="<color:ff0000>";
				}
				
				if(%percentage >= 100){
					%percentage=100;
				}
				
				%percentage=%color @ %percentage @ "%";
				
				centerPrint(%obj.client,"<just:center><color:ffffff>Repairing: " @ %percentage,0.25);
				
			}else{
				%raycast.HP=%maxHP;
				centerPrint(%obj.client,"<just:center><color:ffffff>This piece is<br>fully repaired.",0.25);
			}
			
		}
		
	}
	
}

function SnapHammerImage::onStopFire(%this,%obj,%slot){
	
	%obj.playthread(2, root);
	
}