//Set preference
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")){
	//Make a preferences for the variables.
	RTB_registerPref("Wooden damage reduction (%)", "SnapBuilds", "$Pref::SnapBuilds::WoodenReduction", "int 0 100", "Item_SnapBuilds", 0, 0, 0);
	RTB_registerPref("Stone damage reduction (%)", "SnapBuilds", "$Pref::SnapBuilds::StoneReduction", "int 0 100", "Item_SnapBuilds", 25, 0, 0); 
	RTB_registerPref("Metal damage reduction (%)", "SnapBuilds", "$Pref::SnapBuilds::MetalReduction", "int 0 100", "Item_SnapBuilds", 75, 0, 0); 
    RTB_registerPref("Minigames can damage builds","SnapBuilds","$Pref::SnapBuilds::MinigameDamage","bool","Item_SnapBuilds",1,0,0);
}else{
	$Pref::SnapBuilds::WoodenReduction=0;
	$Pref::SnapBuilds::StoneReduction=25; //Default Starting Money
	$Pref::SnapBuilds::MetalReduction=75; //Default Interest
	$Pref::SnapBuilds::MinigameDamage=true; //Minutes
}

//Start making simset
if(!isObject(MainSnapBuildsGroup)){
	new SimGroup(MainSnapBuildsGroup);
}

//Package the light key for rotation shit
package SnapBuilds{
	
	function GameConnection::autoAdminCheck(%this){
		
		//This function just creates the client's own snapbuildsgroup
		%SnapGroup="SnapBuilds_" @ %this.bl_id;
		
		//Let check if it already exists
		
		%exists=false;
		if(MainSnapBuildsGroup.getCount() > 0){
			
			for(%i=0;%i<MainSnapBuildsGroup.getCount();%i++){
				
				if(%SnapGroup $= MainSnapBuildsGroup.getObject(%i).getName()){
					%exists=true;
					break;
				}
				
			}
			
		}
		
		if(!%exists){
			%SnapGroup=new SimGroup(%SnapGroup);
			MainSnapBuildsGroup.add(%SnapGroup);
		}
		
		%this.SnapBuildsGroup=%SnapGroup;
		%this.SnapRotate=1;
		%this.SnapHammerMode="Destroy";
		
		return Parent::autoAdminCheck(%this);
	}
	
	function servercmdLight(%client){
		
		%image=%client.player.getMountedImage(0);
		if(%image != -1){
			
			if(%image.SnapBuildRotate){
				if(%client.SnapRotate == 4){
					%client.SnapRotate=1;
				}else{
				    %client.SnapRotate++;
				}
				return;
			}
			
			if(%image.getName() $= "SnapHammerImage"){
				
				if(%client.SnapHammerMode $= "Destroy"){
					%client.SnapHammerMode="Repair";
				}else{
					%client.SnapHammerMode="Destroy";
				}
				
				bottomPrint(%client,"<just:center><color:ffffff>SnapHammer Mode:<color:fff000>" SPC %client.SnapHammerMode);
				
				return;
				
			}
			
		}
		
		Parent::servercmdLight(%client);
	}
	
	//Handle projectiles actually damaging these shapes.
	function ProjectileData::onCollision(%this,%obj,%col,%fade,%pos,%normal){
		
		%dmg=%obj.getDatablock().directDamage;
		
		if(%col.getClassName() $= "StaticShape"){
			if(%col.Type $= "Wooden"){
				%dmgReduction=1-($Pref::SnapBuilds::WoodenReduction/100);
			}else if(%col.Type $= "Stone"){
				%dmgReduction=1-($Pref::SnapBuilds::StoneReduction/100);
			}else if(%col.Type $= "Metal"){
				%dmgReduction=1-($Pref::SnapBuilds::MetalReduction/100);
			}
		    if($Pref::SnapBuilds::MinigameDamage && %col.getDatablock().isSnapBuild && %col.getClassName() $= "StaticShape"){
			
		    	%mini1=getMinigameFromObject(%obj.sourceObject.client);
		    	%mini2=getMinigameFromObject(findClientByBL_ID(%col.bl_id));
			
		    	if(!isObject(%mini1) || !isObject(%mini2)){
		    		return;
		    	}
			
		    	if(%mini1 !$= %mini2 || %mini2 !$= %mini1){
		    		return;
		    	}
			
		    	//Check if it is a static shape and a snapbuild
		    	//Before handling the damaging shit.
			
		    	%dmg*=%dmgReduction; //Do reduction first.
			
		    	//Now damage them after checking something first.
		    	if(%col.HP-%dmg <= 0){
		    		%col.delete(); //Delete if it got no health left.
		    	}else{
		    		%col.HP=%col.HP-%dmg;
		    	}
			
		    }
		}
		
		%radius=%obj.getDatablock().explosion.damageRadius;
		%dmg=%obj.getDatablock().explosion.radiusDamage;
	
		if(%dmg && %radius && $Pref::SnapBuilds::MinigameDamage){
		
			initContainerRadiusSearch(%pos,%radius,$TypeMasks::StaticObjectType);
		
			while(%shape=containerSearchNext()){
			
				%mini1=getMinigameFromObject(%obj.sourceObject.client);
				%mini2=getMinigameFromObject(findClientByBL_ID(%shape.bl_id));
			
				if(!isObject(%mini1) || !isObject(%mini2)){
					return;
				}
			
				if(%mini1 !$= %mini2 || %mini2 !$= %mini1){
					continue;
				}
			
				if(!%shape.getDatablock().isSnapBuild){
					continue;
				}
				
				if(!isObject(%shape)){
					continue;
				}
				
				if(%shape.Type $= "Wooden"){
					%dmgReduction=1-($Pref::SnapBuilds::WoodenReduction/100);
				}else if(%shape.Type $= "Stone"){
					%dmgReduction=1-($Pref::SnapBuilds::StoneReduction/100);
				}else if(%shape.Type $= "Metal"){
					%dmgReduction=1-($Pref::SnapBuilds::MetalReduction/100);
				}
			
				%distance=vectorDist(%pos,%shape.getPosition());
			
				//Return if the distance from the center of the piece is not still in range
				if(%distance > %radius){
					continue;
				}
			
				//Only modify the damage if it is greater than 1 in distance.
				//This just prevents increasing damage from explosion due to distances like 0.5
				if(%distance > 1){
					%dmg*=((%radius-%distance)/%radius);
				}
			
				%dmg*=%dmgReduction;
			
				if(%shape.HP - %dmg <= 0){
					%shape.delete();
				}else{
					%shape.HP=%shape.HP-%dmg;
				}
			
			}
		
		}
		
		
		Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	}
	
};activatePackage("SnapBuilds");

datablock StaticShapeData(FloorFrame)
{
  shapeFile = "./FloorFrame.dts";
};

datablock StaticShapeData(FloorStatic)
{
  shapeFile = "./Floor.dts";
  isFloor=true;
  isSnapBuild=true;
};

function CheckFloorPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>(Light key: Rotate the piece.)",0.5);
	
	if(%col != 0){
		
		
		if(%col.getClassName() $= "StaticShape"){
			if(%col.getDatablock().isFloor && %col.bl_id $= %obj.client.bl_id){
				if(%obj.client.SnapRotate == 1){
					%vector="6 0 0";
				}else if(%obj.client.SnapRotate == 2){
					%vector="0 -6 0";
				}else if(%obj.client.SnapRotate == 3){
					%vector="0 6 0";
				}else if(%obj.client.SnapRotate == 4){
					%vector="-6 0 0";
				}
				%pos=vectorAdd(%col.getPosition(),%vector);
			}else{
				return;
			}
		}else{
		    %raypos=posFromRaycast(%raycast);
			%pos=mFloor((getWord(%raypos,0)*10))/10 SPC mFloor((getWord(%raypos,1)*10))/10 SPC mFloor((getWord(%raypos,2)*10))/10;
		}
		
		if(getWord(%pos,2) == -0.1){
			%pos=vectorAdd(%pos,"0 0 0.1");
		}
		
		if(ContainerBoxEmpty($TypeMasks::StaticObjectType | $TypeMasks::FxBrickObjectType,VectorAdd(%pos,"0 0 0.1"),2.9,2.9,0) == 0){
			return;
		}
		
		%shape = new StaticShape(){
			dataBlock=FloorFrame;
			position=%pos;
		};
		
		%obj.client.Placement=%shape;
		
	}else if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
}

function FloorPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0){
		
		if(%col.getClassName() $= "StaticShape"){
			if(%col.getDatablock().isFloor && %col.bl_id $= %obj.client.bl_id){
				if(%obj.client.SnapRotate == 1){
					%vector="6 0 0";
				}else if(%obj.client.SnapRotate == 2){
					%vector="0 -6 0";
				}else if(%obj.client.SnapRotate == 3){
					%vector="0 6 0";
				}else if(%obj.client.SnapRotate == 4){
					%vector="-6 0 0";
				}
				%pos=vectorAdd(%col.getPosition(),%vector);
			}else{
				return;
			}
		}else{
		    %raypos=posFromRaycast(%raycast);
			%pos=mFloor((getWord(%raypos,0)*10))/10 SPC mFloor((getWord(%raypos,1)*10))/10 SPC mFloor((getWord(%raypos,2)*10))/10;
		}
		
		if(getWord(%pos,2) == -0.1){
			%pos=vectorAdd(%pos,"0 0 0.1");
		}
		
		if(ContainerBoxEmpty($TypeMasks::StaticObjectType | $TypeMasks::FxBrickObjectType,VectorAdd(%pos,"0 0 0.1"),2.9,2.9,0) == 0){
			return;
		}
		
		%shape = new StaticShape(){
			dataBlock=FloorStatic;
			position=%pos;
			bl_id=%obj.client.bl_id;
			HP=500;
			Type=%type;
		};
		
		%shape.setNodeColor("ALL",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}

exec("./Floor.cs");


datablock StaticShapeData(PillarFrame)
{
  shapeFile = "./PillarFrame.dts";
};

datablock StaticShapeData(PillarStatic)
{
  shapeFile = "./Pillar.dts";
  isPillar=true;
  isSnapBuild=true;
};

function CheckPillarPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>(Light key: Rotate the piece.)",0.5);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="-3 3 0.2";
		}
		
		//This is just here to check if there is already a pillar there.
		%pos=%col.getPosition();
		
		%pos=vectorAdd(%pos,%vector);
		
		%shape = new StaticShape(){
			dataBlock=PillarFrame;
			position=%pos;
			
		};
		
		%obj.client.Placement=%shape;
		
	}
	
}

function PillarPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%check=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%vector),$TypeMasks::StaticObjectType);
		if(%check != 0){
			if(firstWord(%check).getDatablock().isPillar){
				centerPrint(%obj.client,"You already have<br>placed a piece.",1);
				return;
			}
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		%shape = new StaticShape(){
			dataBlock=PillarStatic;
			position=%pos;
			bl_id=%obj.client.bl_id;
			HP=250;
			Type=%type;
		};
		
		%shape.setNodeColor("ALL",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}


exec("./Pillar.cs");

datablock StaticShapeData(RoofStatic)
{
  shapeFile = "./Floor.dts";
  isRoof=true;
  isSnapBuild=true;
};

function CheckRoofPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::StaticObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		%colc=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%cold=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		
		if(%cola == 0 || %colb == 0 || %colc == 0 || %cold == 0){
			return; //Fail to find any pillars???
		}
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		%colc=firstWord(%colc);
		%cold=firstWord(%cold);
		
		//One last check
		if(!%cola.getDatablock().isPillar){
			return;
		}
		if(!%colb.getDatablock().isPillar){
			return;
		}
		if(!%colc.getDatablock().isPillar){
			return;
		}
		if(!%cold.getDatablock().isPillar){
			return;
		}
		
		%pos=vectorAdd(%col.getPosition(),"0 0 3.8");
		
		%shape = new StaticShape(){
			dataBlock=FloorFrame;
			position=%pos;
		};
		
		%obj.client.Placement=%shape;
		
	}
	
}

function RoofPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		%colc=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%cold=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		
		if(%cola == 0 || %colb == 0 || %colc == 0 || %cold == 0){
			return; //Fail to find any pillars???
		}
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		%colc=firstWord(%colc);
		%cold=firstWord(%cold);
		
		//One last check
		if(!%cola.getDatablock().isPillar){
			return;
		}
		if(!%colb.getDatablock().isPillar){
			return;
		}
		if(!%colc.getDatablock().isPillar){
			return;
		}
		if(!%cold.getDatablock().isPillar){
			return;
		}
		
		%check=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"0 0 3.8"),$TypeMasks::StaticObjectType);
		if(%check != 0){
			if(firstWord(%check).getDatablock().isRoof){
				centerPrint(%obj.client,"You already have<br>placed a piece.",1);
				return;
			}
		}
		
		%pos=vectorAdd(%col.getPosition(),"0 0 3.8");
		
		%shape = new StaticShape(){
			dataBlock=RoofStatic;
			position=%pos;
			bl_id=%obj.client.bl_id;
			HP=250;
			Type=%type;
		};
		
		%shape.setNodeColor("ALL",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}


exec("./Roof.cs");


datablock StaticShapeData(WallFrame)
{
  shapeFile = "./WallFrame.dts";
};

datablock StaticShapeData(WallStatic)
{
  shapeFile = "./Wall.dts";
  isWall=true;
  isSnapBuild=true;
};

function CheckWallPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>(Light key: Rotate the piece.)",0.5);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 0 0.2";
			%PillarA="3 3 0.2";
			%PillarB="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="0 -3 0.2";
			%PillarA="3 -3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 0 0.2";
			%PillarA="-3 3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="0 3 0.2";
			%PillarA="3 3 0.2";
			%PillarB="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarA),$TypeMasks::StaticObjectType);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarB),$TypeMasks::StaticObjectType);
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		
		if(%cola == 0 || %colb == 0){
			return;
		}
		
		if(%cola.getDatablock().isPillar != 1 || %colb.getDatablock().isPillar != 1){
			return;
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		if(%obj.client.SnapRotate == 1 || %obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=WallFrame;
			position=%pos;
			rotation=%rotate;
		};
		
		%obj.client.Placement=%shape;
		
	}
	
}

function WallPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 0 0.2";
			%PillarA="3 3 0.2";
			%PillarB="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="0 -3 0.2";
			%PillarA="3 -3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 0 0.2";
			%PillarA="-3 3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="0 3 0.2";
			%PillarA="3 3 0.2";
			%PillarB="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarA),$TypeMasks::StaticObjectType);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarB),$TypeMasks::StaticObjectType);
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		
		if(%cola == 0 || %colb == 0){
			return;
		}
		
		if(%cola.getDatablock().isPillar != 1 || %colb.getDatablock().isPillar != 1){
			return;
		}
		
		%check=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%vector),$TypeMasks::StaticObjectType);
		if(%check != 0){
			if(firstWord(%check).getDatablock().isWall){
				centerPrint(%obj.client,"You already have<br>placed a piece.",1);
				return;
			}
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		if(%obj.client.SnapRotate == 1 || %obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=WallStatic;
			position=%pos;
			rotation=%rotate;
			bl_id=%obj.client.bl_id;
			HP=375;
			Type=%type;
		};
		
		%shape.setNodeColor("ALL",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}


exec("./Wall.cs");


datablock StaticShapeData(DoorFrame)
{
  shapeFile = "./DoorFrame.dts";
};

datablock StaticShapeData(DoorStatic)
{
  shapeFile = "./Door.dts";
  isWall=true;
  isSnapBuild=true;
};

function CheckDoorPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>(Light key: Rotate the piece.)",0.5);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 0 0.2";
			%PillarA="3 3 0.2";
			%PillarB="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="0 -3 0.2";
			%PillarA="3 -3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 0 0.2";
			%PillarA="-3 3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="0 3 0.2";
			%PillarA="3 3 0.2";
			%PillarB="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarA),$TypeMasks::StaticObjectType);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarB),$TypeMasks::StaticObjectType);
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		
		if(%cola == 0 || %colb == 0){
			return;
		}
		
		if(%cola.getDatablock().isPillar != 1 || %colb.getDatablock().isPillar != 1){
			return;
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		if(%obj.client.SnapRotate == 1 || %obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=DoorFrame;
			position=%pos;
			rotation=%rotate;
		};
		
		%obj.client.Placement=%shape;
		
	}
	
}

function DoorPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 0 0.2";
			%PillarA="3 3 0.2";
			%PillarB="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="0 -3 0.2";
			%PillarA="3 -3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 0 0.2";
			%PillarA="-3 3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="0 3 0.2";
			%PillarA="3 3 0.2";
			%PillarB="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarA),$TypeMasks::StaticObjectType);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarB),$TypeMasks::StaticObjectType);
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		
		if(%cola == 0 || %colb == 0){
			return;
		}
		
		if(%cola.getDatablock().isPillar != 1 || %colb.getDatablock().isPillar != 1){
			return;
		}
		
		%check=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%vector),$TypeMasks::StaticObjectType);
		if(%check != 0){
			if(firstWord(%check).getDatablock().isWall){
				centerPrint(%obj.client,"You already have<br>placed a piece.",1);
				return;
			}
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		if(%obj.client.SnapRotate == 1 || %obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=DoorStatic;
			position=%pos;
			rotation=%rotate;
			bl_id=%obj.client.bl_id;
			HP=375;
			Type=%type;
		};
		
		%shape.setNodeColor("ALL",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}


exec("./Door.cs");


datablock StaticShapeData(WindowFrame)
{
  shapeFile = "./WindowFrame.dts";
};

datablock StaticShapeData(WindowStatic)
{
  shapeFile = "./Window.dts";
  isWall=true;
  isSnapBuild=true;
};

function CheckWindowPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>(Light key: Rotate the piece.)",0.5);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 0 0.2";
			%PillarA="3 3 0.2";
			%PillarB="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="0 -3 0.2";
			%PillarA="3 -3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 0 0.2";
			%PillarA="-3 3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="0 3 0.2";
			%PillarA="3 3 0.2";
			%PillarB="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarA),$TypeMasks::StaticObjectType);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarB),$TypeMasks::StaticObjectType);
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		
		if(%cola == 0 || %colb == 0){
			return;
		}
		
		if(%cola.getDatablock().isPillar != 1 || %colb.getDatablock().isPillar != 1){
			return;
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		if(%obj.client.SnapRotate == 1 || %obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=WindowFrame;
			position=%pos;
			rotation=%rotate;
		};
		
		%obj.client.Placement=%shape;
		
	}
	
}

function WindowPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		if(%obj.client.SnapRotate == 1){
			%vector="3 0 0.2";
			%PillarA="3 3 0.2";
			%PillarB="3 -3 0.2";
		}else if(%obj.client.SnapRotate == 2){
			%vector="0 -3 0.2";
			%PillarA="3 -3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 3){
			%vector="-3 0 0.2";
			%PillarA="-3 3 0.2";
			%PillarB="-3 -3 0.2";
		}else if(%obj.client.SnapRotate == 4){
			%vector="0 3 0.2";
			%PillarA="3 3 0.2";
			%PillarB="-3 3 0.2";
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarA),$TypeMasks::StaticObjectType);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%PillarB),$TypeMasks::StaticObjectType);
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		
		if(%cola == 0 || %colb == 0){
			return;
		}
		
		if(%cola.getDatablock().isPillar != 1 || %colb.getDatablock().isPillar != 1){
			return;
		}
		
		%check=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,%vector),$TypeMasks::StaticObjectType);
		if(%check != 0){
			if(firstWord(%check).getDatablock().isWall){
				centerPrint(%obj.client,"You already have<br>placed a piece.",1);
				return;
			}
		}
		
		%pos=vectorAdd(%pos,%vector);
		
		if(%obj.client.SnapRotate == 1 || %obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=WindowStatic;
			position=%pos;
			rotation=%rotate;
			bl_id=%obj.client.bl_id;
			HP=375;
			Type=%type;
		};
		
		%shape.setNodeColor("a",%color);
		%shape.setNodeColor("b",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}


exec("./Window.cs");


datablock StaticShapeData(StairsStatic)
{
  shapeFile = "./Stairs.dts";
  isRoof=true;
  isSnapBuild=true;
};

datablock StaticShapeData(StairsFrame)
{
  shapeFile = "./StairsFrame.dts";
};

function CheckStairsPlacement(%image,%obj,%slot){
	
	if(!isObject(%obj)){
		return;
	}
	
	if(isObject(%obj.client.Placement)){
		%obj.client.Placement.delete();
	}
	
    %muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::StaticObjectType,%obj);
    %col = firstWord(%raycast);
	
	bottomPrint(%obj.client,"<just:center><color:ffffff>(Light key: Rotate the piece.)",0.5);
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		%colc=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%cold=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		
		if(%cola == 0 || %colb == 0 || %colc == 0 || %cold == 0){
			return; //Fail to find any pillars???
		}
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		%colc=firstWord(%colc);
		%cold=firstWord(%cold);
		
		//One last check
		if(!%cola.getDatablock().isPillar){
			return;
		}
		if(!%colb.getDatablock().isPillar){
			return;
		}
		if(!%colc.getDatablock().isPillar){
			return;
		}
		if(!%cold.getDatablock().isPillar){
			return;
		}
		
		%pos=vectorAdd(%col.getPosition(),"0 0 3.8");
		
		if(%obj.client.SnapRotate == 1){
			%rotate="0 0 1 270";
		}else if(%obj.client.SnapRotate == 2){
			%rotate="0 0 1 180";
		}else if(%obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=StairsFrame;
			position=%pos;
			rotation=%rotate;
		};
		
		%obj.client.Placement=%shape;
		
	}
	
}

function StairsPlace(%image,%obj,%slot,%type){
	
	if(%type $= "Wooden"){
		%color="0.66 0.46 0.27 1.0";
	}else if(%type $= "Stone"){
		%color="0.59 0.59 0.59 1.0";
	}else if(%type $= "Metal"){
		%color="0.86 0.86 0.86 1.0";
	}
	
	%muzzlepoint = %obj.getMuzzlePoint(0);
    %muzzlevec = %obj.getMuzzleVector(0);
    %raycast = containerRayCast(%muzzlepoint,VectorAdd(%muzzlepoint,VectorScale(%muzzlevec,5)),$TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
    %col = firstWord(%raycast);
	
	
	if(%col != 0 && %col.getClassName() $= "StaticShape"){
		
		if(!%col.getDatablock().isRoof && !%col.getDatablock().isFloor){
			return;
		}
		
		if(%col.bl_id !$= %obj.client.bl_id){
			return;
		}
		
		%pos=%col.getPosition();
		
		%cola=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%colb=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		%colc=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 3 0.8"),$Typemasks::StaticObjectType,%col);
		%cold=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"-3 -3 0.8"),$Typemasks::StaticObjectType,%col);
		
		if(%cola == 0 || %colb == 0 || %colc == 0 || %cold == 0){
			return; //Fail to find any pillars???
		}
		
		%cola=firstWord(%cola);
		%colb=firstWord(%colb);
		%colc=firstWord(%colc);
		%cold=firstWord(%cold);
		
		//One last check
		if(!%cola.getDatablock().isPillar){
			return;
		}
		if(!%colb.getDatablock().isPillar){
			return;
		}
		if(!%colc.getDatablock().isPillar){
			return;
		}
		if(!%cold.getDatablock().isPillar){
			return;
		}
		
		%check=containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"0 0 3.8"),$TypeMasks::StaticObjectType);
		if(%check != 0){
			if(firstWord(%check).getDatablock().isRoof){
				centerPrint(%obj.client,"You already have<br>placed a piece.",1);
				return;
			}
		}
		
		%pos=vectorAdd(%col.getPosition(),"0 0 3.8");
		
		if(%obj.client.SnapRotate == 1){
			%rotate="0 0 1 270";
		}else if(%obj.client.SnapRotate == 2){
			%rotate="0 0 1 180";
		}else if(%obj.client.SnapRotate == 3){
			%rotate="0 0 1 90";
		}else{
			%rotate="0 0 1 0";
		}
		
		%shape = new StaticShape(){
			dataBlock=StairsStatic;
			position=%pos;
			rotation=%rotate;
			bl_id=%obj.client.bl_id;
			HP=250;
			Type=%type;
		};
		
		%shape.setNodeColor("ALL",%color);
		
		%obj.client.SnapBuildsGroup.add(%shape);
		
	}
	
}

//Lastly let make a bunch of commands :)
function servercmdClearSnapBuilds(%client){
	announce("<color:00ff00>" @ %client.name @ " <color:fff000>had cleared their SnapBuilds.");
	
	for(%c=%client.SnapBuildsGroup.getCount()-1;%c>-1;%c--){
		%client.SnapBuildsGroup.getObject(%c).delete();
	}
	
}

function servercmdClearAllSnapBuilds(%client){
	if(%client.isSuperAdmin){
		announce("<color:00ff00>" @ %client.name @ " <color:fff000>had cleared everyone's SnapBuilds.");
		
		for(%b=0;%b<MainSnapBuildsGroup.getCount();%b++){
			%SnapGroup=MainSnapBuildsGroup.getObject(%b);
			for(%c=%SnapGroup.getCount()-1;%c>-1;%c--){
				%SnapGroup.getObject(%c).delete();
			}
		}
		
	}else{
		messageClient(%client,"","\c0Only Superadmins can use this command.");
	}
}


exec("./Stairs.cs");

//Delete Item
exec("./SnapHammer.cs");